- name: Resolves current version
  set_fact:
    current_rgw_version: "{{ (rgw_dc.resources[0].spec.template.spec.containers[0].image.split(':'))[1]
                                 if ((deployment_kind == 'Deployment' or (do_triggers | default(False)) == False)
                                     and rgw_dc.resources[0].spec.template is defined
                                     and rgw_dc.resources[0].spec.template.spec is defined
                                     and rgw_dc.resources[0].spec.template.spec.containers is defined
                                     and rgw_dc.resources[0].spec.template.spec.containers[0] is defined
                                     and rgw_dc.resources[0].spec.template.spec.containers[0].image is defined
                                     and (rgw_dc.resources[0].spec.template.spec.containers[0].image.split(':')) | length == 2)
                                 else ((rgw_dc.resources[0].spec.template.spec.containers[0].image.split(':'))[2]
                                     if ((deployment_kind == 'Deployment' or (do_triggers | default(False)) == False)
                                         and rgw_dc.resources[0].spec.template is defined
                                         and rgw_dc.resources[0].spec.template.spec is defined
                                         and rgw_dc.resources[0].spec.template.spec.containers is defined
                                         and rgw_dc.resources[0].spec.template.spec.containers[0] is defined
                                         and rgw_dc.resources[0].spec.template.spec.containers[0].image is defined)
                                     else (rgw_dc.resources[0].spec.triggers[0].imageChangeParams.from.name.split(':'))[1]) }}"
- block:
  - name: Fails if current version unknown
    fail:
      msg: "RadosGW tag unknown {{ current_rgw_version }}"
    when:
    - current_rgw_version not in [ '15.2.13', '17.2.0', '17.2.5' ]
  - name: Checks upgrade supported
    fail:
      msg: "Can not upgrade from {{ current_rgw_version }} to {{ radosgw_tag }}"
    when:
    - >
        (current_rgw_version == '17.2.5' and radosgw_tag in [ '15.2.13', '17.2.0' ])
        or (current_rgw_version == '17.2.0' and radosgw_tag in [ '15.2.13' ])
  when:
  - current_rgw_version != 'master'
  - current_rgw_version != 'devel'
  - current_rgw_version != 'stage'
- name: Issue a warning when migrating from master to release
  debug:
    msg: |
      WARNING - about to deploy {{ radosgw_tag }} over CI version {{ current_rgw_version }}
  when:
  - current_rgw_version in [ 'master', 'devel', 'stage' ]
